#!/bin/bash
# SPDX-Version: 3.0
# SPDX-CreationInfo: 2025-06-17; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-ExternalRef: GIT https://git.coresecret.dev/msw/CISS.debian.installer.git
# SPDX-FileContributor: WEIDNER, Marc S.; Centurion Intelligence Consulting Agency
# SPDX-FileCopyrightText: 2024-2025; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-FileType: SOURCE
# SPDX-License-Identifier: EUPL-1.2 OR LicenseRef-CCLA-1.0
# SPDX-LicenseComment: This file is part of the CISS.debian.installer.secure framework.
# SPDX-PackageName: CISS.debian.installer
# SPDX-Security-Contact: security@coresecret.eu

guard_sourcing

#######################################
# Validate all preseed network variables (IPv4 & IPv6)
# Arguments:
#   None
#######################################
validation_preseed() {
  declare var value

  ### --- IPv4 variables ------------------------------------------------------
  declare -a ipv4_vars=(
    network_static_ipv4nameserver_0
    network_static_ipv4nameserver_1
    network_static_ipv4nameserver_fallback_0
    network_static_ipv4nameserver_fallback_1
    network_static_ipv4address
    network_static_ipv4gateway
  )

  ### --- IPv6 variables ------------------------------------------------------
  declare -a ipv6_vars=(
    network_static_ipv6nameserver_0
    network_static_ipv6nameserver_1
    network_static_ipv6nameserver_fallback_0
    network_static_ipv6nameserver_fallback_1
    network_static_ipv6address
  )

  ### --- loop over both groups ----------------------------------------------
  for var in "${ipv4_vars[@]}"; do
    value="${!var}"
    if [[ -n "${value}" ]]; then
      validation_ipv4 "${value}"
    else
      do_log "info" "true" "'${var}' is not set."
    fi
  done

  for var in "${ipv6_vars[@]}"; do
    value="${!var}"
    if [[ -n "${value}" ]]; then
      validation_ipv6 "${value}"
    else
      do_log "info" "false" "'${var}' is not set."
    fi
  done

  return 0
}
# vim: number et ts=2 sw=2 sts=2 ai tw=128 ft=sh
